unit uList;


interface

uses Classes;

type
    TDListItem = class
    private
    public
    end;


    TDList = class (TList)

    private
       autoDelete : boolean;

       procedure DelItems;

    public
       constructor Create (bAutoDelete : boolean);
       destructor Destroy; override;

       procedure Clear;
    end;


implementation

constructor TDList.Create (bAutoDelete : boolean);
begin
  inherited Create;
  autoDelete := bAutoDelete;
end;

destructor TDList.Destroy;
begin
  Assert (self <> nil);
  DelItems;
  inherited Destroy;
end;

procedure TDList.Clear;
begin
  DelItems;
  inherited Clear; 
end;

procedure TDList.DelItems;
var
  i : integer;
begin
  if autoDelete then
    for i:= 0 to Count-1 do
      TDListItem(Items[i]).Free;
end;


end.
